<template>
  <AppPage>
    <h1>Change Courses' Homepages</h1>
    <p>Change the homepage of all courses for the given institution and term</p>
    <b-card bg-variant="danger" v-if="!hasPermission('post:courses-homepages')">
      You do not have permission to update course homepages
    </b-card>
    <div v-if="hasPermission('post:courses-homepages')">
      <b-overlay :show="change_course_homepage_fetching">
        <CampusDDL v-model="campus" class="mb-3"/>
        <TermSelector v-model="term"/>
        <b-form-input
            class="mt-3"
            id="txtHomepage"
            name="txtHomepage"
            v-model="homepage"
            type="number"
            placeholder="Homepage LMS ID"
            required
        ></b-form-input>
        <b-button
            class="mt-3"
            :disabled="!submittable"
            variant="primary"
            @click="confirmSubmit"
        >Change Homepage on all Courses
        </b-button
        >
        <b-modal
            id="mdlConfirm"
            v-model="confirmModal"
            @ok="submitConfirmed"
            title="Warning"
            header-bg-variant="danger"
            header-text-variant="light"
        >
          <p class="my-4">Are you sure?</p>
          <p>
            This action cannot be undone. While you are able to re-run this to
            change the homepage on the courses again, the original homepage that
            was set for the courses is not recorded anywhere, and thus cannot be
            restored.
          </p>
          <p class="my-4">
            There is no validation on the homepage id ({{ homepage }}) that you
            provided, please make sure it is correct.
          </p>
          <p class="my-4">
            This will change the homepage on ALL courses in
            <span class="font-weight-bold">{{ term }}</span> for
            <span class="font-weight-bold">{{ campus }}</span
            >.
          </p>
        </b-modal>
      </b-overlay>
      <div class="mt-5" v-show="change_course_homepage_fetching">
        <b-card
            bg-variant="danger"
            text-variant="white"
            header="Warning"
            title="Update in Progress"
        >
          <b-card-text>
            Please do not navigate away from this page. Your request will take a
            very long time. If you navigate away from this page, the operation
            will still continue in the background, but you will not see whether
            it was successful or not.
          </b-card-text>
        </b-card>
      </div>
      <div class="mt-5" v-show="show_results">
        <b-card
            header="Operation Results"
            title="Success"
            v-show="change_course_homepage_errors === null"
        >
          <b-card-text>
            Operation successful on all {{ campus }} courses for the term,
            {{ term }}
          </b-card-text>
          <b-button @click.stop.prevent="finish_operation"
          >Acknowledge to run operation again
          </b-button
          >
        </b-card>
        <b-card
            header="Operation Results"
            title="Error(s)"
            v-show="change_course_homepage_errors !== null"
        >
          <b-button class="my-2" @click.stop.prevent="finish_operation"
          >Acknowledge to run operation again
          </b-button
          >
          <p class="my-2">The operation produced the following error(s):</p>
          <b-table class="my-2" striped :items="change_course_homepage_errors">
          </b-table>
          <b-button class="my-2" @click.stop.prevent="finish_operation"
          >Acknowledge to run operation again
          </b-button
          >
        </b-card>
      </div>
    </div>
  </AppPage>
</template>

<script>
import { mapGetters, mapActions, mapMutations } from 'vuex';

export default {
  data () {
    return {
      campus: null,
      term: '',
      homepage: '',
      confirmModal: false
    };
  },
  computed: {
    ...mapGetters({
      change_course_homepage_fetching: 'Courses/Homepage/change_course_homepage_fetching',
      change_course_homepage_errors: 'Courses/Homepage/change_course_homepage_errors',
      change_course_homepage_in_progress: 'Courses/Homepage/change_course_homepage_in_progress',
      hasPermission: 'Navbar/hasPermission',
      showAdminHelpInfo: 'Navbar/showAdminHelpInfo'
    }),
    int_homepage () {
      if (this.homepage.length <= 0) {
        return 0;
      }

      let h = parseInt(this.homepage);
      if (isNaN(h)) {
        return 0;
      }

      if (h <= 0) {
        return 0;
      }

      return h;
    },
    submittable () {
      if (this.campus === null || this.campus.length <= 0) {
        return false;
      }

      if (this.term.length <= 0) {
        return false;
      }

      if (this.change_course_homepage_in_progress) {
        return false;
      }

      return this.int_homepage > 0;
    },
    show_results () {
      return (
          this.change_course_homepage_fetching === false &&
          this.change_course_homepage_in_progress === true
      );
    }
  },
  methods: {
    ...mapActions({ update_course_homepages: 'Courses/Homepage/update_course_homepages' }),
    ...mapMutations({ set_change_course_homepage_in_progress: 'Courses/Homepage/set_change_course_homepage_in_progress' }),
    confirmSubmit () {
      if (this.hasPermission('post:courses-homepages')) {
        this.confirmModal = true;
      }
    },
    submitConfirmed () {
      if (this.hasPermission('post:courses-homepages')) {
        let payload = {
          institution: this.campus,
          term: this.term,
          homepage: this.homepage
        };

        this.update_course_homepages(payload);
      }
    },
    finish_operation () {
      this.set_change_course_homepage_in_progress(false);
    }
  }
};
</script>
